Index: /palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- /palm/trunk/SOURCE/salsa_mod.f90	(revision 3863)
+++ /palm/trunk/SOURCE/salsa_mod.f90	(revision 3864)
@@ -9181,7 +9473,6 @@
 !> Subroutine defining 2D output variables
 !------------------------------------------------------------------------------!
- SUBROUTINE salsa_data_output_2d( av, variable, found, grid, mode, local_pf,   &
-                                  two_d, nzb_do, nzt_do )
- 
+ SUBROUTINE salsa_data_output_2d( av, variable, found, grid, mode, local_pf, two_d, nzb_do, nzt_do )
+
     USE indices
 
@@ -9191,434 +9482,76 @@
     IMPLICIT NONE
 
-    CHARACTER (LEN=*) ::  grid       !< 
-    CHARACTER (LEN=*) ::  mode       !< 
-    CHARACTER (LEN=*) ::  variable   !<
-    CHARACTER (LEN=5) ::  vari       !<  trimmed format of variable
-
-    INTEGER(iwp) ::  av      !< 
-    INTEGER(iwp) ::  b       !< running index: size bins
-    INTEGER(iwp) ::  c       !< running index: mass bins
-    INTEGER(iwp) ::  i       !<
-    INTEGER(iwp) ::  icc     !< index of a chemical compound
-    INTEGER(iwp) ::  j       !< 
-    INTEGER(iwp) ::  k       !< 
-    INTEGER(iwp) ::  nzb_do  !< 
-    INTEGER(iwp) ::  nzt_do  !< 
-
-    LOGICAL ::  found        !< 
-    LOGICAL ::  two_d        !< flag parameter that indicates 2D variables 
-                             !< (horizontal cross sections)
-    
-    REAL(wp) ::  df          !< For calculating LDSA: fraction of particles 
-                             !< depositing in the alveolar (or tracheobronchial)
-                             !< region of the lung. Depends on the particle size 
-    REAL(wp) ::  fill_value = -9999.0_wp  !< value for the _FillValue attribute                          
-    REAL(wp) ::  mean_d      !< Particle diameter in micrometres
-    REAL(wp) ::  nc          !< Particle number concentration in units 1/cm**3
-    REAL(wp) ::  temp_bin    !< temporary array for calculating output variables
-    
+    CHARACTER(LEN=*) ::  grid       !<
+    CHARACTER(LEN=*) ::  mode       !<
+    CHARACTER(LEN=*) ::  variable   !<
+    CHARACTER(LEN=5) ::  vari       !<  trimmed format of variable
+
+    INTEGER(iwp) ::  av           !<
+    INTEGER(iwp) ::  found_index  !< index of a chemical compound
+    INTEGER(iwp) ::  i            !<
+    INTEGER(iwp) ::  ib           !< running index: size bins
+    INTEGER(iwp) ::  ic           !< running index: mass bins
+    INTEGER(iwp) ::  j            !<
+    INTEGER(iwp) ::  k            !<
+    INTEGER(iwp) ::  nzb_do       !<
+    INTEGER(iwp) ::  nzt_do       !<
+
+    LOGICAL ::  found  !<
+    LOGICAL ::  two_d  !< flag parameter to indicate 2D variables (horizontal cross sections)
+
+    REAL(wp) ::  df                       !< For calculating LDSA: fraction of particles
+                                          !< depositing in the alveolar (or tracheobronchial)
+                                          !< region of the lung. Depends on the particle size
+    REAL(wp) ::  fill_value = -9999.0_wp  !< value for the _FillValue attribute
+    REAL(wp) ::  mean_d                   !< Particle diameter in micrometres
+    REAL(wp) ::  nc                       !< Particle number concentration in units 1/cm**3
+    REAL(wp) ::  temp_bin                 !< temporary array for calculating output variables
+
     REAL(wp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do) ::  local_pf  !< output
-    
+
     REAL(wp), DIMENSION(:,:,:), POINTER ::  to_be_resorted           !< pointer
-    
 !
 !-- Next statement is to avoid compiler warning about unused variable. May be removed in future.
     IF ( two_d )  CONTINUE
-    
+
     found = .TRUE.
     temp_bin  = 0.0_wp
-    
-    IF ( TRIM( variable(1:2) ) == 'g_' )  THEN
-       vari = TRIM( variable( 3:LEN( TRIM( variable ) ) - 3 ) )
-       IF ( av == 0 )  THEN
-          IF ( vari == 'H2SO4')  icc = 1
-          IF ( vari == 'HNO3')   icc = 2
-          IF ( vari == 'NH3')    icc = 3
-          IF ( vari == 'OCNV')   icc = 4
-          IF ( vari == 'OCSV')   icc = 5
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb_do, nzt_do
-                   local_pf(i,j,k) = MERGE( salsa_gas(icc)%conc(k,j,i),        &
-                                            REAL( fill_value, KIND = wp ),     &
-                                            BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                ENDDO
-             ENDDO
-          ENDDO
-       ELSE
-          IF ( vari == 'H2SO4' )  to_be_resorted => g_H2SO4_av
-          IF ( vari == 'HNO3' )   to_be_resorted => g_HNO3_av   
-          IF ( vari == 'NH3' )    to_be_resorted => g_NH3_av   
-          IF ( vari == 'OCNV' )   to_be_resorted => g_OCNV_av   
-          IF ( vari == 'OCSV' )   to_be_resorted => g_OCSV_av        
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb_do, nzt_do
-                   local_pf(i,j,k) = MERGE( to_be_resorted(k,j,i),             &
-                                            REAL( fill_value, KIND = wp ),     &
-                                            BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                ENDDO
-             ENDDO
-          ENDDO
-       ENDIF
-
-       IF ( mode == 'xy' )  grid = 'zu'
-
-    ELSEIF ( TRIM( variable(1:4) ) == 'LDSA' )  THEN
-       IF ( av == 0 )  THEN
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb_do, nzt_do
-                   temp_bin = 0.0_wp
-                   DO  b = 1, nbins
-!                      
-!--                   Diameter in micrometres
-                      mean_d = 1.0E+6_wp * Ra_dry(k,j,i,b) * 2.0_wp 
-!                               
-!--                   Deposition factor: alveolar                               
-                      df = ( 0.01555_wp / mean_d ) * ( EXP( -0.416_wp * ( LOG( &
-                             mean_d ) + 2.84_wp )**2.0_wp ) + 19.11_wp * EXP(  &
-                            -0.482_wp * ( LOG( mean_d ) - 1.362_wp )**2.0_wp ) )
-!                                    
-!--                   Number concentration in 1/cm3
-                      nc = 1.0E-6_wp * aerosol_number(b)%conc(k,j,i)
-!                         
-!--                   Lung-deposited surface area LDSA (units mum2/cm3)                       
-                      temp_bin = temp_bin + pi * mean_d**2.0_wp * df * nc 
-                   ENDDO
-                   local_pf(i,j,k) = MERGE( temp_bin, REAL( fill_value, KIND = & 
-                                            wp ), BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                ENDDO
-             ENDDO
-          ENDDO
-       ELSE
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb_do, nzt_do
-                   local_pf(i,j,k) = MERGE( LDSA_av(k,j,i), REAL( fill_value,  &
-                                            KIND = wp ), BTEST(                &
-                                            wall_flags_0(k,j,i), 0 ) ) 
-                ENDDO
-             ENDDO
-          ENDDO
-       ENDIF
-
-       IF ( mode == 'xy' )  grid = 'zu'
-       
-    ELSEIF ( TRIM( variable(1:5) ) == 'N_bin' )  THEN
-       
-       vari = TRIM( variable( 6:LEN( TRIM( variable ) ) - 3 ) )
-    
-       IF ( TRIM( vari ) == '1' ) b = 1
-       IF ( TRIM( vari ) == '2' ) b = 2
-       IF ( TRIM( vari ) == '3' ) b = 3
-       IF ( TRIM( vari ) == '4' ) b = 4
-       IF ( TRIM( vari ) == '5' ) b = 5
-       IF ( TRIM( vari ) == '6' ) b = 6
-       IF ( TRIM( vari ) == '7' ) b = 7
-       IF ( TRIM( vari ) == '8' ) b = 8
-       IF ( TRIM( vari ) == '9' ) b = 9
-       IF ( TRIM( vari ) == '10' ) b = 10
-       IF ( TRIM( vari ) == '11' ) b = 11
-       IF ( TRIM( vari ) == '12' ) b = 12
-       
-       IF ( av == 0 )  THEN
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb_do, nzt_do                      
-                   local_pf(i,j,k) = MERGE( aerosol_number(b)%conc(k,j,i),     &
-                                            REAL( fill_value, KIND = wp ),     &
-                                            BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                ENDDO
-             ENDDO
-          ENDDO
-       ELSE
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb_do, nzt_do                      
-                   local_pf(i,j,k) = MERGE( Nbins_av(k,j,i,b),                 &
-                                            REAL( fill_value, KIND = wp ),     &
-                                            BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                ENDDO
-             ENDDO
-          ENDDO
-       ENDIF
-       
-       IF ( mode == 'xy' )  grid = 'zu'
-    
-    ELSEIF ( TRIM( variable(1:4) ) == 'Ntot' )  THEN
-       IF ( av == 0 )  THEN
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb_do, nzt_do
-                   temp_bin = 0.0_wp
-                   DO  b = 1, nbins
-                      temp_bin = temp_bin + aerosol_number(b)%conc(k,j,i)
-                   ENDDO
-                   local_pf(i,j,k) = MERGE( temp_bin, REAL( fill_value, KIND = &
-                                            wp ), BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                ENDDO
-             ENDDO
-          ENDDO
-       ELSE
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb_do, nzt_do
-                   local_pf(i,j,k) = MERGE( Ntot_av(k,j,i), REAL( fill_value,  &
-                                            KIND = wp ), BTEST(                &
-                                            wall_flags_0(k,j,i), 0 ) ) 
-                ENDDO
-             ENDDO
-          ENDDO
-       ENDIF
-
-       IF ( mode == 'xy' )  grid = 'zu'
-    
-    
-    ELSEIF ( TRIM( variable(1:5) ) == 'm_bin' )  THEN
-       
-       vari = TRIM( variable( 6:LEN( TRIM( variable ) ) - 3 ) )
-    
-       IF ( TRIM( vari ) == '1' ) b = 1
-       IF ( TRIM( vari ) == '2' ) b = 2
-       IF ( TRIM( vari ) == '3' ) b = 3
-       IF ( TRIM( vari ) == '4' ) b = 4
-       IF ( TRIM( vari ) == '5' ) b = 5
-       IF ( TRIM( vari ) == '6' ) b = 6
-       IF ( TRIM( vari ) == '7' ) b = 7
-       IF ( TRIM( vari ) == '8' ) b = 8
-       IF ( TRIM( vari ) == '9' ) b = 9
-       IF ( TRIM( vari ) == '10' ) b = 10
-       IF ( TRIM( vari ) == '11' ) b = 11
-       IF ( TRIM( vari ) == '12' ) b = 12
-       
-       IF ( av == 0 )  THEN
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb_do, nzt_do   
-                   temp_bin = 0.0_wp
-                   DO  c = b, ncc_tot * nbins, nbins
-                      temp_bin = temp_bin + aerosol_mass(c)%conc(k,j,i)
-                   ENDDO
-                   local_pf(i,j,k) = MERGE( temp_bin, REAL( fill_value,        &
-                                            KIND = wp ), BTEST(                &
-                                            wall_flags_0(k,j,i), 0 ) )
-                ENDDO
-             ENDDO
-          ENDDO
-       ELSE
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb_do, nzt_do                      
-                   local_pf(i,j,k) = MERGE( mbins_av(k,j,i,b), REAL( fill_value,&
-                                            KIND = wp ), BTEST(                &
-                                            wall_flags_0(k,j,i), 0 ) ) 
-                ENDDO
-             ENDDO
-          ENDDO
-       ENDIF
-       
-       IF ( mode == 'xy' )  grid = 'zu'
-    
-    ELSEIF ( TRIM( variable(1:5) ) == 'PM2.5' )  THEN
-       IF ( av == 0 )  THEN
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb_do, nzt_do
-                   temp_bin = 0.0_wp
-                   DO  b = 1, nbins
-                      IF ( 2.0_wp * Ra_dry(k,j,i,b) <= 2.5E-6_wp )  THEN
-                         DO  c = b, nbins*ncc, nbins
-                            temp_bin = temp_bin + aerosol_mass(c)%conc(k,j,i)
-                         ENDDO
-                      ENDIF
-                   ENDDO
-                   local_pf(i,j,k) = MERGE( temp_bin, REAL( fill_value,        &
-                                            KIND = wp ), BTEST(                &
-                                            wall_flags_0(k,j,i), 0 ) ) 
-                ENDDO
-             ENDDO
-          ENDDO
-       ELSE
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb_do, nzt_do
-                   local_pf(i,j,k) = MERGE( PM25_av(k,j,i), REAL( fill_value,  &
-                                            KIND = wp ), BTEST(                &
-                                            wall_flags_0(k,j,i), 0 ) ) 
-                ENDDO
-             ENDDO
-          ENDDO
-       ENDIF
-
-       IF ( mode == 'xy' )  grid = 'zu'
-    
-    
-    ELSEIF ( TRIM( variable(1:4) ) == 'PM10' )  THEN
-       IF ( av == 0 )  THEN
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb_do, nzt_do
-                   temp_bin = 0.0_wp
-                   DO  b = 1, nbins
-                      IF ( 2.0_wp * Ra_dry(k,j,i,b) <= 10.0E-6_wp )  THEN
-                         DO  c = b, nbins*ncc, nbins
-                            temp_bin = temp_bin + aerosol_mass(c)%conc(k,j,i)
-                         ENDDO
-                      ENDIF
-                   ENDDO
-                   local_pf(i,j,k) = MERGE( temp_bin,  REAL( fill_value,       &
-                                            KIND = wp ), BTEST(                &
-                                            wall_flags_0(k,j,i), 0 ) ) 
-                ENDDO
-             ENDDO
-          ENDDO
-       ELSE
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb_do, nzt_do
-                   local_pf(i,j,k) = MERGE( PM10_av(k,j,i), REAL( fill_value,  &
-                                            KIND = wp ), BTEST(                &
-                                            wall_flags_0(k,j,i), 0 ) ) 
-                ENDDO
-             ENDDO
-          ENDDO
-       ENDIF
-
-       IF ( mode == 'xy' )  grid = 'zu'
-    
-    ELSEIF ( TRIM( variable(1:2) ) == 's_' )  THEN
-       vari = TRIM( variable( 3:LEN( TRIM( variable ) ) - 3 ) )
-       IF ( is_used( prtcl, vari ) )  THEN
-          icc = get_index( prtcl, vari )
+
+    SELECT CASE ( TRIM( variable( 1:LEN( TRIM( variable ) ) - 3 ) ) )  ! cut out _xy, _xz or _yz
+
+       CASE ( 'g_H2SO4', 'g_HNO3', 'g_NH3', 'g_OCNV', 'g_OCSV' )
+          vari = TRIM( variable( 3:LEN( TRIM( variable ) ) - 3 ) )
           IF ( av == 0 )  THEN
+             IF ( vari == 'H2SO4')  found_index = 1
+             IF ( vari == 'HNO3')   found_index = 2
+             IF ( vari == 'NH3')    found_index = 3
+             IF ( vari == 'OCNV')   found_index = 4
+             IF ( vari == 'OCSV')   found_index = 5
              DO  i = nxl, nxr
                 DO  j = nys, nyn
                    DO  k = nzb_do, nzt_do
-                      temp_bin = 0.0_wp
-                      DO  c = ( icc-1 )*nbins+1, icc*nbins, 1
-                         temp_bin = temp_bin + aerosol_mass(c)%conc(k,j,i)
-                      ENDDO
-                      local_pf(i,j,k) = MERGE( temp_bin, REAL( fill_value,     &
-                                               KIND = wp ), BTEST(             &
-                                               wall_flags_0(k,j,i), 0 ) ) 
+                      local_pf(i,j,k) = MERGE( salsa_gas(found_index)%conc(k,j,i), REAL( fill_value, &
+                                               KIND = wp ),  BTEST( wall_flags_0(k,j,i), 0 ) ) 
                    ENDDO
                 ENDDO
              ENDDO
           ELSE
-             IF ( vari == 'BC' )   to_be_resorted => s_BC_av
-             IF ( vari == 'DU' )   to_be_resorted => s_DU_av   
-             IF ( vari == 'NH' )   to_be_resorted => s_NH_av   
-             IF ( vari == 'NO' )   to_be_resorted => s_NO_av   
-             IF ( vari == 'OC' )   to_be_resorted => s_OC_av   
-             IF ( vari == 'SO4' )  to_be_resorted => s_SO4_av   
-             IF ( vari == 'SS' )   to_be_resorted => s_SS_av       
+             IF ( vari == 'H2SO4' )  to_be_resorted => g_h2so4_av
+             IF ( vari == 'HNO3' )   to_be_resorted => g_hno3_av
+             IF ( vari == 'NH3' )    to_be_resorted => g_nh3_av
+             IF ( vari == 'OCNV' )   to_be_resorted => g_ocnv_av
+             IF ( vari == 'OCSV' )   to_be_resorted => g_ocsv_av
              DO  i = nxl, nxr
                 DO  j = nys, nyn
                    DO  k = nzb_do, nzt_do
-                      local_pf(i,j,k) = MERGE( to_be_resorted(k,j,i),          &
-                                               REAL( fill_value, KIND = wp ),  &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) ) 
+                      local_pf(i,j,k) = MERGE( to_be_resorted(k,j,i), REAL( fill_value,            &
+                                               KIND = wp ), BTEST( wall_flags_0(k,j,i), 0 ) )
                    ENDDO
                 ENDDO
              ENDDO
           ENDIF
-       ELSE
-          local_pf = fill_value
-       ENDIF
-
-       IF ( mode == 'xy' )  grid = 'zu'
-       
-    ELSE
-       found = .FALSE.
-       grid  = 'none'
-    
-    ENDIF
- 
- END SUBROUTINE salsa_data_output_2d
-
- 
-!------------------------------------------------------------------------------!
-!
-! Description:
-! ------------
-!> Subroutine defining 3D output variables
-!------------------------------------------------------------------------------!
- SUBROUTINE salsa_data_output_3d( av, variable, found, local_pf, nzb_do,       &
-                                  nzt_do )
-
-    USE indices
-
-    USE kinds
-    
-
-    IMPLICIT NONE
-
-    CHARACTER (LEN=*), INTENT(in) ::  variable   !< 
-    
-    INTEGER(iwp) ::  av      !<
-    INTEGER(iwp) ::  b       !< running index: size bins    
-    INTEGER(iwp) ::  c       !< running index: mass bins
-    INTEGER(iwp) ::  i       !<
-    INTEGER(iwp) ::  icc     !< index of a chemical compound
-    INTEGER(iwp) ::  j       !< 
-    INTEGER(iwp) ::  k       !< 
-    INTEGER(iwp) ::  nzb_do  !< 
-    INTEGER(iwp) ::  nzt_do  !<   
-
-    LOGICAL ::  found      !< 
-    
-    REAL(wp) ::  df        !< For calculating LDSA: fraction of particles 
-                           !< depositing in the alveolar (or tracheobronchial)
-                           !< region of the lung. Depends on the particle size 
-    REAL(wp) ::  fill_value = -9999.0_wp   !< value for the _FillValue attribute
-    REAL(wp) ::  mean_d    !< Particle diameter in micrometres
-    REAL(wp) ::  nc        !< Particle number concentration in units 1/cm**3
-    REAL(wp) ::  temp_bin  !< temporary array for calculating output variables    
-
-    REAL(sp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do) ::  local_pf  !< local 
-    
-    REAL(wp), DIMENSION(:,:,:), POINTER ::  to_be_resorted  !< pointer
-                                                     
-       
-    found     = .TRUE.
-    temp_bin  = 0.0_wp
-    
-    SELECT CASE ( TRIM( variable ) )
-    
-       CASE ( 'g_H2SO4', 'g_HNO3', 'g_NH3', 'g_OCNV',  'g_OCSV' )
-          IF ( av == 0 )  THEN
-             IF ( TRIM( variable ) == 'g_H2SO4')  icc = 1
-             IF ( TRIM( variable ) == 'g_HNO3')   icc = 2
-             IF ( TRIM( variable ) == 'g_NH3')    icc = 3
-             IF ( TRIM( variable ) == 'g_OCNV')   icc = 4
-             IF ( TRIM( variable ) == 'g_OCSV')   icc = 5
-             
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb_do, nzt_do
-                      local_pf(i,j,k) = MERGE( salsa_gas(icc)%conc(k,j,i),     &
-                                               REAL( fill_value, KIND = wp ),  &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             IF ( TRIM( variable(3:) ) == 'H2SO4' ) to_be_resorted => g_H2SO4_av
-             IF ( TRIM( variable(3:) ) == 'HNO3' )  to_be_resorted => g_HNO3_av   
-             IF ( TRIM( variable(3:) ) == 'NH3' )   to_be_resorted => g_NH3_av   
-             IF ( TRIM( variable(3:) ) == 'OCNV' )  to_be_resorted => g_OCNV_av   
-             IF ( TRIM( variable(3:) ) == 'OCSV' )  to_be_resorted => g_OCSV_av 
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb_do, nzt_do
-                      local_pf(i,j,k) = MERGE( to_be_resorted(k,j,i),          &
-                                               REAL( fill_value, KIND = wp ),  &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-          
+
+          IF ( mode == 'xy' )  grid = 'zu'
+
        CASE ( 'LDSA' )
           IF ( av == 0 )  THEN
